Changes to bldpkg:

* Replaced echo with cat for generating summary and fixed related code
* Added -o option for copying alternate build file
* Fixed identation for help usage
* Moved all code related to validating build files into a function 'validatebldfile'
* Use printf for colours
* Added miscellaneous supporting code and comments
This commit is contained in:
PktSurf 2022-09-04 23:01:12 +05:30
parent 94d439e7b2
commit 8c90307be6

408
bldpkg
View file

@ -26,15 +26,8 @@
# not belonging to the current build are present inside tmpfs
# -> Write code to log build output to a log file inside a particular directory
# -> Add code to show extended help?
# -> Often times it happens that there are two package build files, one
# being the original package build file that has been backed up and the
# package build file whose stuff such as source directory extraction and
# patches are commented out for testing and yet the build is initialised
# from this modified build file. Also, the package build file the build was invoked from
# gets copied in the resulting package installer for reference. We'd like the
# original package build file to be copied and not the modified package build
# file. Use -o <orig_bld_file> -m <modified_bld_file> for doing this, perhaps?
# -> Email the user about the outcome of the build?
# -> Use 'cat' instead of 'echo' for generating summary
# Determine whether we are using bash version 4 and later. If not, exit.
if ((BASH_VERSINFO[0] < 4)) ; then
@ -71,29 +64,35 @@ Building package 'alsa-lib' version '1.x'...
...build output...
Usage:
-d : Produce a package with debug symbols preserved, i.e., don't strip resulting
ELF objects. Uses -g3 by default.
-e : Extract the package installer file in the user's PWD if the build
completes successfully.
-d Produce a package with debug symbols preserved, i.e., don't strip
resulting ELF objects. Uses -g3 by default.
-f : Name of an alternate build file to source build variables. Should be
compatible with standard SMLinux package build file format.
-e Extract the package installer file in the user's PWD if the build
completes successfully.
-g : Generate SHA512 checksums of all tarballs and patches in the current
directory and insert them into the package build file
-f <file> Name of an alternate build file to source build variables. Should
be compatible with standard SMLinux package build file format.
-h : Show this help message
-g Generate SHA512 checksums of all tarballs and patches in the current
directory and insert them into the package build file
-j<N> : Provide a number of jobs to be run simultaneously
-h Show this help message
-s : Display build summary. A summary is produced whenever a build is either
interrupted, exits cleanly or aborts due to a build error
-j <N> Provide a number of jobs to be run simultaneously
-x : Invoke bash shell command trace mode. This one isn't akin to running
bash -x <script> but close enough, because the mode is inserted
half way while bldpkg is running
-o <file> Copy this file into the package installer rather than the default one
the build was initiated from. Usually the default one is either
<app>.SMBuild or the one supplied using -f <file> but in certain
exceptional cases a different file is required to be copied into the
package installer. Do note that this file will also undergo validation
-s Display build summary. A summary is produced whenever a build is either
interrupted, exits cleanly or aborts due to a build error
-x Invoke bash shell command trace mode. This one isn't akin to running
bash -x <script> but close enough, because the mode is inserted half-way
while bldpkg is running
EOF
exit 0
}
@ -108,6 +107,76 @@ else
exit 1
fi
# Function to validate the build file.
validatebldfile() {
local buildfile
buildfile=$1
if [[ ! -f $buildfile ]] ; then
echo "[ERROR] No build file to validate from!"
exit 1
fi
(
source $buildfile
# If any of the following variables are not set in the build file, abort.
for buildvariables in app version build homepage desc requires ; do
if [[ ! ${!buildvariables} ]] ; then
echo "[ERROR] Required variable \"${buildvariables}\" is not set. Please check your build file."
exit 1
fi
if egrep -q "$buildvariables='*'" "$buildfile" ; then
echo "[ERROR] Please dont use single quotes to define the \"${buildvariables}\" variable"
exit 1
fi
done
# Validate $app
if ! echo "$app" | egrep -q '^[a-z0-9-]+$' ; then
echo "[ERROR] Only lower case, numeric characters and dash allowed in the '"'app'"' variable in the build file."
exit 1
fi
# Validate $version
if ! echo "$version" | egrep -q '^[a-z0-9.]+$' ; then
echo "[ERROR] Only lower case, numeric characters and a period allowed in the '"'version'"' variable in the build file."
exit 1
fi
# Validate $homepage
if ! echo "$homepage" | egrep -q '^http://|^https://|^ftp://' ; then
echo "[ERROR] Invalid URL in the '"'homepage'"' variable in the build file."
exit 1
fi
# Validate $download, first the URL type
if [[ -n $download ]]; then
if ! echo "$download" | egrep -q '^http://|^https://|^ftp://' ; then
echo "[ERROR] Invalid URL in the '"'download'"' variable in the build file."
exit 1
fi
# Then check for single quotes
if egrep -q "download='*'" "$buildfile" ; then
echo "[ERROR] Single quotes disallowed in the download variable"
exit 1
fi
fi
# Validate $desc using bash shell's ability to count variable length
if [[ ${#desc} -gt 100 ]] ; then
echo "[ERROR] Package description should not exceed 100 characters in the build file."
exit 1
fi
# Check if build() function exists in the build file
if ! egrep -q '^build()' $buildfile ; then
echo "[ERROR] build() function does not exist in your build file."
exit 1
fi
)
}
# Store the source directory path the build was initiated from
srcdir="$PWD"
@ -118,16 +187,15 @@ buildfile="$(basename $srcdir).SMBuild"
# Find all required files. If either of them don't exist, abort.
rqfiles=( makepkg installpkg upgradepkg sha512sum patch find findmnt patch tput bc tar )
for requiredfile in ${rqfiles[@]};
do
if [[ ! -x $(type -p $requiredfile) ]] ; then
echo "[ERROR] Could not find $requiredfile!"
exit 1
fi
done
for requiredfile in ${rqfiles[@]}; do
if [[ ! -x $(type -p $requiredfile) ]] ; then
echo "[ERROR] Could not find $requiredfile!"
exit 1
fi
done
# Function for providing handy arguments to users. Some will override bldpkg.conf.
while getopts ':def:ghj:sx' option; do
while getopts ':def:ghj:o:sx' option; do
case "$option" in
d) debug=1 ;; # Produce a debug build with -g3
e) extractprompt=0;
@ -136,6 +204,7 @@ while getopts ':def:ghj:sx' option; do
g) genchecksum=1 ;;
h) help ;;
j) customcputhreads="$OPTARG" ;;
o) origbuildfile="$OPTARG" ;;
s) showsummary=1 ;; # Show build summary at the end of the build irrespective of the build status
x) set -xv ;; # Invoke bash's -x option for command tracing
*) help ;;
@ -152,6 +221,7 @@ if [[ $OPTIND = 1 ]] ; then
echo "[ERROR] Try -f <build_file> if your build file has a different name (Not recommended)"
exit 1
else
validatebldfile $buildfile
source "$buildfile"
fi
@ -170,17 +240,40 @@ elif [[ $OPTIND -gt 1 ]] ; then
exit 1
fi
# If $origbuildfile is set and is a file, check if $setbuildfile and $origbuildfile are the same
if [[ -n $origbuildfile ]] ; then
if [[ ! -f $origbuildfile ]] ; then
echo "[ERROR] Original build file $origbuildfile does not exist!"
exit 1
fi
if [[ -n $setbuildfile ]] && [[ -f $setbuildfile ]] ; then
if [[ $origbuildfile = $setbuildfile ]] ; then
echo "[ERROR] Original build file and alternate build file are the same!"
exit 1
fi
fi
validatebldfile "$origbuildfile"
fi
# If $setbuildfile is set and is a file, set buildfile to its value, source it and initialise the build
if [[ -n $setbuildfile ]] && [[ -f $setbuildfile ]] ; then
buildfile="$setbuildfile"
validatebldfile $buildfile
source "$buildfile"
# If $setbuildfile is set but a file passed as an argument is not found, give an error
elif [[ -n $setbuildfile ]] && [[ ! -f $setbuildfile ]] ; then
echo "[ERROR] $setbuildfile not found!"
exit 1
# If the above two conditions don't meet, get the presumed $buildfile value as a file and source it
elif [[ -f "$buildfile" ]] ; then
validatebldfile $buildfile
source "$buildfile"
# If even that file is not found, throw an error and exit
else
echo "[ERROR] No package build file to source from!"
@ -219,63 +312,6 @@ if [[ $genchecksum = 1 ]] ; then
exit 0
fi
# Validate the build file. If any of the following variables are not set in the build file, abort.
for buildvariables in app version build homepage desc requires ; do
if [[ ! ${!buildvariables} ]] ; then
echo "[ERROR] Required variable \"${buildvariables}\" is not set. Please check your build file."
exit 1
fi
if egrep -q "$buildvariables='*'" "$buildfile" ; then
echo "[ERROR] Please dont use single quotes to define the \"${buildvariables}\" variable"
exit 1
fi
done
# Validate $app
if ! echo "$app" | egrep -q '^[a-z0-9-]+$' ; then
echo "[ERROR] Only lower case, numeric characters and dash allowed in the '"'app'"' variable in the build file."
exit 1
fi
# Validate $version
if ! echo "$version" | egrep -q '^[a-z0-9.]+$' ; then
echo "[ERROR] Only lower case, numeric characters and a period allowed in the '"'version'"' variable in the build file."
exit 1
fi
# Validate $homepage
if ! echo "$homepage" | egrep -q '^http://|^https://|^ftp://' ; then
echo "[ERROR] Invalid URL in the '"'homepage'"' variable in the build file."
exit 1
fi
# Validate $download, first the URL type
if [[ -n $download ]]; then
if ! echo "$download" | egrep -q '^http://|^https://|^ftp://' ; then
echo "[ERROR] Invalid URL in the '"'download'"' variable in the build file."
exit 1
fi
fi
# Then check for single quotes
if egrep -q "download='*'" "$buildfile" ; then
echo "[ERROR] Single quotes disallowed in the download variable"
exit 1
fi
# Validate $desc using bash shell's ability to count variable length
if [[ ${#desc} -gt 100 ]] ; then
echo "[ERROR] Package description should not exceed 100 characters in the build file."
exit 1
fi
# Check if build() function exists in the build file
if ! egrep -q '^build()' $buildfile ; then
echo "[ERROR] build() function does not exist in your build file."
exit 1
fi
# Display the package and its version we are building
echo "[INFO] Building package $app version $version ..."
sleep 0.5
@ -291,10 +327,13 @@ if [[ $useauditd = 1 ]] ; then
# First clear out the log file
auditlogfile="/var/log/audit/audit.log"
echo > $auditlogfile
# Now run auditd
/bin/auditd -n &
# Store the PID inside a variable
auditpid=$!
# Note: auditd writes about 6-8 lines for our setup when initialized.
echo "[INFO] Auditd initialised."
fi
@ -346,7 +385,10 @@ fi
# Function to output to the user which patch is about to be applied. Useful when there are many
# patches and you want to determine which patch failed.
applypatch() {
# Take patch file name as the first argument
patchfile="$1"
# Perform a simple check
if [[ -z $patchfile ]] ; then
echo "[ERROR] Please provide valid patch file name"
exit 1
@ -354,9 +396,13 @@ applypatch() {
echo "[ERROR] Patch file not found!"
exit 1
fi
# Get relative path to the patch file
relativepath="$(basename $patchfile)"
echo "[INFO] Applying patch $relativepath.."
patch -p1 < "$patchfile"
# Grab the exit code and determine the outcome
patchresult=$?
if [[ $patchresult != 0 ]] ; then
echo "[ERROR] Patch file $patchfile failed to apply!"
@ -534,7 +580,8 @@ if [[ $usetmpfs = 1 ]] && [[ -n $tmpfsdir ]] && [[ -z $tmpfscheckfailed ]] ; the
preservebuilddir=0
preservepackagedir=0
# Get the directory from the tmpfsdir variable for extracting the source and set it as our build and staging directory
# Get the directory from the tmpfsdir variable for extracting the source and set it as our build
# and staging directory
tmp="$tmpfsdir/$app.src"
pkg="${pkg:-$tmpfsdir/package-$app}"
@ -556,7 +603,7 @@ else
export MAKEFLAGS
fi
# Validate all compilers
# Validate all compilers starting with distcc
# Validate everything related to distcc if globaldistcc is set
if [[ $globaldistcc = 1 ]] ; then
# Check if distcc exists and is an executable
@ -637,9 +684,8 @@ if [[ $globaldistcc = 1 ]] ; then
# We only run distccd on TCP port 3632
if ! /bin/nc -z -w 1 "$host" 3632 > /dev/null 2>&1 ; then
echo "[WARNING] Distcc host '"$host"' is OFFLINE"
sleep 0.5
echo "Rewriting DISTCC_HOSTS"
DISTCC_HOSTS="$(echo $DISTCC_HOSTS | sed "s@$host/[a-z0-9,]*@@")"
echo "Rewriting DISTCC_HOSTS"
DISTCC_HOSTS="$(echo $DISTCC_HOSTS | sed "s@$host/[a-z0-9,]*@@")"
fi
done
fi
@ -976,10 +1022,10 @@ removestaticlibs() {
# To be invoked inside a package build file.
mkfinalpkg() {
# Now we attempt to split the total time we'll get when making the summary into two times: compile time and
# packaging time. Here we store the value of $SECONDS variable the moment makefinalpkg is invoked. We use this
# value as the compile time, because this is the next function that's called by the build script the moment a
# successful compile make install DESTDIR=$pkg or something similar.
# Now we attempt to split the total time we'll get when making the summary into two times: compile
# time and packaging time. Here we store the value of $SECONDS variable the moment makefinalpkg is
# invoked. We use this value as the compile time, because this is the next function that's called
# by the build script the moment a successful compile make install DESTDIR=$pkg or something similar.
# compiletimea will store the exact seconds
compiletimea="$SECONDS"
@ -1046,7 +1092,12 @@ EOF
find "$pkg" -type f -name "*.la" -delete
# Provide a copy of the package build file so that users know the build options that went into compiling the package
install -Dm 644 "$srcdir/$buildfile" "$pkgdocs/$buildfile"
if [[ -n $origbuildfile ]] && [[ -f $srcdir/$origbuildfile ]] ; then
install -Dm 644 "$srcdir/$origbuildfile" "$pkgdocs/$app.SMBuild"
else
install -Dm 644 "$srcdir/$buildfile" "$pkgdocs/$app.SMBuild"
fi
# We don't want multiple directories for documentation. Detect if $pkg/share/doc/<app-name> was created.
# If it has been created, move its contents into $pkgdocs and discard the old doc directory.
@ -1057,8 +1108,8 @@ EOF
rmdir "$pkg/share/doc/$app"
fi
# Normally we'd expect some debug symbols in the newly-produced binaries. But that isn't always the case with some
# packages whose build systems strip objects before hand
# Normally we'd expect some debug symbols in the newly-produced binaries. But that isn't always the
# case with some packages whose build systems strip objects before hand
if [[ $debug = 1 ]] ; then
for file in \
$( find "$pkg" )
@ -1112,8 +1163,9 @@ EOF
echo "[INFO] Leaving staging directory $pkg"
# cd back to $srcdir when preservepackagedir is set to 0 to prevent this error: shell-init: error retrieving
# current directory: getcwd: cannot access parent directories: No such file or directory
# cd back to $srcdir when preservepackagedir is set to 0 to prevent this error:
# shell-init: error retrieving current directory: getcwd: cannot access parent directories:
# No such file or directory
echo "[INFO] Re-entering source directory $srcdir"
cd "$srcdir"
@ -1198,17 +1250,17 @@ prepbuildoutput() {
colourscheck="$(tput colors 2>/dev/null)"
if [[ "$?" = 0 ]] && [[ $colourscheck -gt 2 ]] ; then
# Red when the build fails
colourr="\e[41m"
colourr="$(printf '\e[41m')"
# Yellow when the build is interrupted
coloury="\e[93m"
coloury="$(printf '\e[93m')"
# Green when the build succeeds
colourg="\e[92m"
colourg="$(printf '\e[92m')"
# Cyan for the short questions
colourc="\e[96m"
colourc="$(printf '\e[96m')"
# App name/version colours
colourv="\e[92m"
colourv="$(printf '\e[92m')"
# Restore to default
colourd="\e[0m"
colourd="$(printf '\e[0m')"
fi
fi
@ -1225,7 +1277,9 @@ prepbuildoutput() {
# Determine if distcc was used. If globaldistcc is enabled and set to 1 and distcc is not declared in the
# package build file, then set dstats in the build summary
if [[ $globaldistcc = 1 ]] && [[ -z $distcc ]]; then
dstats="Yes"
# If distcc was used, cut out --randomize and output rest of the DISTCC_HOSTS variable
distccvar="$(echo "$DISTCC_HOSTS" | sed 's@--randomize@@')"
dstats="Yes,$distccvar"
# Else if globaldistcc is enabled and set to 1 and distcc is set to 0 in the package build file, then set
# dstats in the build summary
elif [[ $globaldistcc = 1 ]] && [[ $distcc = 0 ]]; then
@ -1240,16 +1294,18 @@ prepbuildoutput() {
# However, if we are compiling inside tmpfs, we are not using ccache at all. So we set cstats accordingly
# in the build summary
if [[ $globalccache = 1 ]] && [[ $usetmpfs = 1 ]] && [[ $tmpfsenabledforthispackage = 1 ]] ; then
cstats="Enabled globally but disabled due to tmpfs"
cstats="Enabled globally but disabled due to tmpfs"
elif [[ $globalccache = 1 ]] && [[ -n $usetmpfs ]] && [[ $usetmpfs = 0 ]] ; then
cstats="Yes"
elif [[ $globalccache = 1 ]] && [[ $usetmpfs = 0 ]] && [[ -z $ccache ]] ; then
ccacheusedsize="$(ccache -s | grep "cache size" | head -n 1 | awk '{ $1=$2="" ; print $0}' | sed 's@ @@g')"
ccachetotalsize="$(ccache -s | grep "max cache size" | awk '{ $1=$2=$3="" ; print $0}' | sed 's@ @@g')"
cstats="Yes, $ccacheusedsize / $ccachetotalsize Allocated"
elif [[ $globalccache = 1 ]] && [[ -z $usetmpfs ]] ; then
cstats="Yes"
cstats="Yes"
elif [[ -z $globalccache ]] || [[ $globalccache = 0 ]] ; then
cstats="No, disabled globally"
cstats="No, disabled globally"
fi
@ -1286,105 +1342,65 @@ prepbuildoutput() {
# Determine if the build was successful or not
if [[ $pkgstatus = 0 ]] ; then
bldstatus="$(echo -e "$colourg"'Successful! :-D' "$colourd")"
# Determine the compressed size
packsize="$(du -bk "$newpkglocation" | awk '{print $1}')"
# Determine the uncompressed size
packusize="$(echo $packusize1)"
elif [[ $wasinterrupted = 1 ]]; then
bldstatus="$(echo -e "$coloury"'** INTERRUPTED ** :-/'"$colourd")"
else
bldstatus="$(echo -e "$colourr"'!! FAILED !! :-('"$colourd")"
fi
# Finally prepare the summary
echo "" >> "$tempfile"
echo -e ""$colourc"-------------------------------------------------------------------------------" >> "$tempfile"
echo -e " BUILD SUMMARY FOR PACKAGE "$colourd"'"$colourv"\
"$app""$colourd"'"$colourc" VERSION "$colourd"'"$colourv""$version"'" "$colourc"TAG"$colourv" "'$build'"$colourd"" >> "$tempfile"
echo -e ""$colourc"-------------------------------------------------------------------------------"$colourd"" >> "$tempfile"
echo -e ""$colourc" Build Status:"$colourd" $bldstatus" >> "$tempfile"
# Output the section name if autobuildtemp is set. This means we are running an autobuild.
if [[ -n $autobuildtemp ]]; then
echo -e ""$colourc" Build Section:"$colourd" $section" >> "$tempfile"
fi
# If we have $compiletimeb set, then assume the compile went well and output compile and packaging times into tempfile.
if [[ -n $totaltime ]] && [[ -z $packagetimeb ]]; then
echo -e ""$colourc" Total Time: "$colourd" $totaltime" >> "$tempfile"
elif [[ -n $totaltime ]] && [[ -n $packagetimeb ]]; then
echo -e ""$colourc" Total Time: "$colourd" $totaltime ( $compiletimeb Compile ) + ( $packagetimeb Packaging )" >> "$tempfile"
fi
echo -e ""$colourc" Started:"$colourd" $commencedate" >> "$tempfile"
echo -e ""$colourc" Stopped:"$colourd" $finishdate" >> "$tempfile"
# If the package was built successfully, output the installer sizes
if [[ $pkgstatus = 0 ]]; then
#compressedsize="$(echo $(($packsize * 100 / $packusize)))"
# If the package was built successfully, output the installer sizes
# Space saving = 1 - Compressed Size / Uncompressed size.
# Also, bc code taken from:
# https://stackoverflow.com/questions/56945130/bash-echo-percentage-with-no-decimal-point-with-result-returned-from-bc-comman
compressedsize="$(echo $(echo "scale=2 ; 1 - "$packsize" / "$packusize"" | bc ) | sed 's@.@@')"
echo -e ""$colourc" Source Size: "$colourd" Compressed: $srcdirsize"K", Uncompressed: $builddirsize"K"" >> "$tempfile"
bldstatus="$colourg Successful! :-D $colourd
Source Size: $colourd Compressed: $srcdirsize"K", Uncompressed: $builddirsize"K"
Package Size: $colourd Uncompressed: $packusize"K", Compressed: $packsize"K" ("$compressedsize'%'")
Package Has: $colourd $totalfilecount files and $totalsymcount symlinks in $totaldircount directories"
echo -e ""$colourc" Package Size: "$colourd" Uncompressed: $packusize"K", Compressed: $packsize"K" ("$compressedsize'%'")" >> "$tempfile"
elif [[ $wasinterrupted = 1 ]]; then
bldstatus="$coloury ** INTERRUPTED ** :-/ $colourd"
echo -e ""$colourc" Package Has: "$colourd" $totalfilecount files and $totalsymcount symlinks in $totaldircount directories" >> "$tempfile"
else
bldstatus="$colourr !! FAILED !! :-( $colourd"
fi
# Finally prepare the summary
# If ccache was used, output the current cache used size and max allocated size
if [[ $globalccache = 1 ]] && [[ $ccache != 0 ]] && [[ $cstats = Yes ]]; then
ccacheusedsize="$(ccache -s | grep "cache size" | head -n 1 | \
awk '{ $1=$2="" ; print $0}')"
ccachetotalsize="$(ccache -s | grep "max cache size" | \
awk '{ $1=$2=$3="" ; print $0}')"
echo -e ""$colourc" Ccache Used?"$colourd" "$cstats","$ccacheusedsize" /"$ccachetotalsize" Allocated" >> "$tempfile"
# If we have $compiletimeb set, then assume the compile went well and output compile and packaging times into tempfile.
if [[ -n $totaltime ]] && [[ -z $packagetimeb ]]; then
ttime="$totaltime"
elif [[ -n $totaltime ]] && [[ -n $packagetimeb ]]; then
ttime="$totaltime ( $compiletimeb Compile ) + ( $packagetimeb Packaging )"
fi
# Output the section name if autobuildtemp is set. This means we are running an autobuild.
if [[ -n $autobuildtemp ]]; then
bsection="$section"
else
echo -e ""$colourc" Ccache Used?"$colourd" "$cstats"" >> "$tempfile"
bsection="None"
fi
echo -e ""$colourc" Distcc Used?"$colourd" $dstats" >> "$tempfile"
# If distcc was used, cut out --randomize and output rest of the DISTCC_HOSTS variable
if [[ $globaldistcc = 1 ]] && [[ $distcc != 0 ]]; then
echo -e ""$colourc" Distcc Args: "$colourd" $(echo "$DISTCC_HOSTS" | sed 's@--randomize@@')" >> "$tempfile"
fi
echo -e ""$colourc" TMPFS Used? "$colourd" "$tmpfsstate" $tmpfssavingsize" >> "$tempfile"
echo -e ""$colourc" CPU Threads: "$colourd" $(echo $makeflags | sed 's@-j@@')" >> "$tempfile"
echo -e ""$colourc" CFLAGS Used: "$colourd" $CFLAGS" >> "$tempfile"
echo -e ""$colourc" Compressor: "$colourd" $compressor ($compressopts)" >> "$tempfile"
echo -e ""$colourc" Build Type:" $colourd" $buildsys & $bldtype" >> "$tempfile"
echo -e ""$colourc"-------------------------------------------------------------------------------"$colourd"" >> "$tempfile"
cat << EOF > "$tempfile"
$colourc ------------------------------------------------------------------------------- $colourd
$colourc BUILD SUMMARY FOR PACKAGE $colourv'$app'$colourc VERSION $colourv'$version'$colourc TAG $colourv'$build'
$colourc ------------------------------------------------------------------------------- $colourd
$colourc Build Status: $colourd $bldstatus
$colourc Build Section: $colourd $bsection
$colourc Total Time: $colourd $ttime
$colourc Started: $colourd $commencedate
$colourc Stopped: $colourd $finishdate
$colourc Ccache Used? $colourd $cstats
$colourc Distcc Used? $colourd $dstats
$colourc TMPFS Used? $colourd $tmpfsstate $tmpfssavingsize
$colourc CPU Threads: $colourd $(echo $makeflags | sed 's@-j@@')
$colourc CFLAGS Used: $colourd $CFLAGS
$colourc Compressor: $colourd $compressor ($compressopts)
$colourc Build Type: $colourd $buildsys & $bldtype
$colourc ------------------------------------------------------------------------------- $colourd
EOF
# Output the build summary to the user on every build
cat "$tempfile"
@ -1432,9 +1448,9 @@ promptuser() {
echo "[INFO] '"$app"' package installer file successfully extracted"
fi
# Prompt the user at the end of a build whether to extract contents of a newly-built installer into a subdirectory
# called "test" inside the package source directory the build was manually initiated from. Has no effect on
# autobuilds since they are simply installed right away.
# Prompt the user at the end of a build whether to extract contents of a newly-built installer
# into a subdirectory called "test" inside the package source directory the build was manually initiated from.
# Has no effect on autobuilds since they are simply installed right away.
if [[ $extractprompt = 1 ]] && [[ -z $autobuild ]] && [[ -n $newpkglocation ]] ; then
while true ; do
echo